; **************** SDR AD9951 ***************

.include "m48def.inc"

;*********   ****************
; R0      -    
; R1      -   
; R20-R25 -     DDS
; R13-R16 -  
; R17,R18 - TEMP
; R19     - 
; R20     -   

;************   *************
; FTW99 = (FTW98*2)/2^16
; FTW99 -   AD9951  Ft = 400 Mhz (4 )
; FTW98 -   AD9854  Ft = 200 Mhz (6 )

; FTW = Fout*2^32/Ft
; Ft = 400 mhz

;************    *************
; FTW = Frx*2*2^32/Ft  2 MSB

;***********  *************
.equ    MaxState   =11    ; max  
.equ    MaxDPF     =9     ; - 

;********************************************************************
;* Interrupt table
;********************************************************************
.cseg
;--------------------------------------------------------------------
.org $0000                 ; after reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
.org $0004
     rjmp  PCINT1_handler
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
     rjmp Reset
.org $001A
Reset:
    cli                 ;  
;  
    ldi   R17,high(RAMEND)
    out   SPH,R17         ; Set Stack Pointer to top of RAM
    ldi   R17,low(RAMEND)
    out   SPL,R17
    clr   R17
    out   EECR,R17        ; EEPROM
;  PORTD
    out   PORTD,R17       ; Pull UP - disable PORTD - IN
    out   DDRD,R17
;  PORTC
    ldi   R17,0x24        ; 0010.0100
    out   PORTC,R17       ; (PC2-PC5) = 9,  
    ldi   R17,0x3C        ; 0011.1100
    out   DDRC,R17        ; PC2-PC5 - OUT
;  PORTB
    ldi   R17,0x00        ; 0000.0000
    out   PORTB,R17       ; PB = 0
    ldi   R17,0x2F        ; 0010.1111
    out   DDRB,R17        ; PB4 - IN
; 
    ldi   R17,(1<<ACD)|(1<<ACI) ; $90 
    out   ACSR,R17
    clr   R17
    sts   DIDR1,R17
;  ADC
    sts   DIDR0,R17
    sts   ADMUX,R17
    sts   ADCSRB,R17
    sts   ADCSRA,R17
;  INT0, INT1
    sts   EICRA,R17
    out   EIMSK,R17
;    PC0, PC1
    ldi   R17,0x07      ; 0000.0111
    sts   PCIFR,R17     ;  
    ldi   R17,0x02      ; 0000.0010
    sts   PCICR,R17     ;  PCIE1
    clr   R17           ;  . PC0, PC1
    sts   PCMSK2,R17
    sts   PCMSK0,R17
    ldi   R17,0x03
    sts   PCMSK1,R17
;  SPI
    ldi   R17,0x52      ; 0101.0010 Master, mode 0, MSB first, f/64
    out   SPCR,R17
    clr   R17
    out   SPSR,R17
;  
    in    R16,PINC      ; . PC
    clr   XL            ;  100H
    ldi   XH,0x01
    clr   YL
    ldi   YH,0x01
    sei                 ;  .
    ldi   R17,0x01      ; PLL Mult =1
    mov   R0,R17
;  FTW=0
    ldi   R20,0x04      ; instruction
    clr   R21           ; FTW=0
    clr   R22           ; /
    clr   R23           ; /
    clr   R24           ; /
    ldi   R17,5         ; - 
    rcall SndDDS        ;  FTW
    ldi   R17,0x01      ; PLL Mult =1
    mov   R0,R17

;*****************   ****************
;  
RefMult:
    clr   R20
    clr   R21
    clr   R22
    clr   R23
    ldi   R24,0x42
    ldi   R17,5        ; - 
    rcall SndDDS       ; CFR1
    ldi   R20,0x01
    clr   R21
    clr   R22
    mov   R23,R0       ; PLL Mult
    lsl   R23
    lsl   R23
    lsl   R23          ; xxxx.x000
    sbr   R23,0x04     ; xxxx.x100: VCO=250...400
    ldi   R17,4        ; - 
    rcall SndDDS       ; CFR2
    ldi   R20,0x02
    clr   R21
    clr   R22
    ldi   R17,3        ; - 
    rcall SndDDS       ; ASF
    ldi   R20,0x03
    clr   R21
    ldi   R17,2        ; - 
    rcall SndDDS       ; ARR
    ldi   R20,0x05
    clr   R21
    clr   R22
    ldi   R17,3        ; - 
    rcall SndDDS       ; POW0
StateNew:
    clr   R19           ;   
WaitRX:
    ldi   YH,0x01       ;   100H...1FFH
Wait1:
    cp    YL,XL         ; YL-XL  (RD-WR)
    breq  Wait1         ;    
;   , 
    ld    R17,Y+        ; 1-   
    cpi   R17,0x01
    breq  SndDat
    cpi   R17,0x02
    breq  SndAdr
    adiw  Y,1           ; ,   x01  x10
    rjmp  WaitRX        ;  
SndDat:
    ld    R0,Y+         ;  
NewRX:
    inc   R19           ; . 
    rjmp  WaitRX        ; 
SndAdr:
     ld    R20,Y+       ;  
     cpi   R19, (MaxState+1) ;  
     brsh  StateNew     ; , State >max
     ldi   ZH,HIGH (GoState)
     ldi   ZL,LOW (GoState)
     add   ZL,R19       ;   
     clr   R17
     adc   ZL,R17       ; /
     ijmp
State1:
     cpi   R20,0x1E     ; RefMult
     breq  RefMult      ; - 
     cpi   R20,0x04
     brne  StateNew     ;   04
     mov   R21,R0       ; Frq Word 47:40
     rjmp  NewRX
State3:
     cpi   R20,0x05
     brne  StateNew     ;   05
     mov   R22,R0       ; Frq Word 39:32
     rjmp  NewRX
State5:
     cpi   R20,0x06
     brne  StateNew     ;   06
     mov   R23,R0       ; Frq Word 31:24
     rjmp  NewRX
State7:
     cpi   R20,0x07
     brne  StateNew     ;   07
     mov   R24,R0       ; Frq Word 23:16
     rjmp  NewRX
State9:
     cpi   R20,0x08
     brne  StateNew     ;   08
     mov   R25,R0       ; Frq Word 15:8
     rjmp  NewRX
State11:
     cpi   R20,0x09
     brne  StateNew     ;   09
;  F==0
     clr   R18
     or    R18,R21
     or    R18,R22
     or    R18,R23
     or    R18,R24
     breq  FrqRdy1      ; F=0
;   
     ser   R18          ; R18=FF
     ldi   ZH,high(TabDPF*2) ;    . 
     ldi   ZL,low(TabDPF*2)  ; /
CntDPF:
     inc   R18          ;   
     lpm   R1,Z+        ; LSB FTW
     cp    R22,R1       ; LSB (FTW_F - FTW_DPF)
     lpm   R1,Z+        ; MSB FTW
     cpc   R21,R1       ; MSB (FTW_F - FTW_DPF)
     brlo  MulF         ; FTW_F < FTW_DPF
     cpi   R18,(MaxDPF-2)
     brne  CntDPF
     inc   R18
     rjmp  FrqRdy       ; F>30mHz,  
MulF:
     rol   R25          ; F<30mHz, Frq Word *2
     rol   R24          ; /
     rol   R23          ; /
     rol   R22          ; /
     rol   R21          ; /
FrqRdy:
;     PC2-PC5
     lsl   R18
     lsl   R18          ; 00xx.xx00
     out   PORTC,R18
FrqRdy1:
;  FTW
     ldi   R20,0x04     ; instruction
     ldi   R17,5        ; - 
     rcall SndDDS       ; FTW
     rjmp  StateNew     ;  

;  
GoState:
     rjmp  StateNew     ; 0 - ,   
     rjmp  State1
     rjmp  StateNew     ; 2 - ,   
     rjmp  State3
     rjmp  StateNew     ; 4 - ,   
     rjmp  State5
     rjmp  StateNew     ; 6 - ,   
     rjmp  State7
     rjmp  StateNew     ; 8 - ,   
     rjmp  State9
     rjmp  StateNew     ; 10 - ,   
     rjmp  State11

; /  SPI
; : R17 - - 
;       R20...R25 - 
; : R18
SndDDS:
     ldi   ZL,20        ; R20
     clr   ZH
SndDDSBt:
     ld    R18,Z+
     out   SPDR,R18
WaitTrn:
     in    R18,SPSR     ; Wait for transmission complete
     sbrs  R18,SPIF
     rjmp  WaitTrn
     dec   R17
     brne  SndDDSBt
     sbi   PORTB,PB2    ; UPD=1
     ldi   R17,80       ; ~20mks
     dec   R17
     brne  PC-1
     cbi   PORTB,PB2    ; UPD=0
     ret

; /  PCINT1
; : X -  
;       R16 -  . PC
; : R13,R14,R15
PCINT1_handler:
    in    R13,SREG      ; 
    in    R14,PIND
    in    R15,PINC
    eor   R16,R15       ; 1 - 
    and   R16,R15       ; 1 - _|
    andi  R16,0x03      ; 0000.00xx
    breq  NotSave       ;   0
    cpi   R16,0x02
    brne  ChkEnd        ; 
    sbrc  R14,7         ; ,  RESET
    rjmp  Notsave       ; RESET=1,  
    sbrc  R14,6         ; ,  WRB
    rjmp  NotSave       ; WRB=1,  
ChkEnd:
    st    X+,R16        ; 
    st    X+,R14        ; 
    ldi   XH,0x01       ;   100H...1FFH
NotSave:
    mov   R16,R15       ; . . PC
    out   SREG,R13
    reti

;   DPF
TabDPF:
    .dw   $0333         ; 2,5
    .dw   $051F         ; 4
    .dw   $07AE         ; 6
    .dw   $0958         ; 7,3
    .dw   $0F5C         ; 12
    .dw   $1290         ; 14,5
    .dw   $1B85         ; 21,5
    .dw   $2667         ; 30

